//fuzzywobble.com
//March 2019


//0 – waiting
//1 – proximity triggered, ringing
//2 – in use
//3 – hangup, idle for XXXXms
int MODE = 0;


int DEBUG = true; //check the serail monitor for debug output
bool REPLAY_MODE = true; 
bool PLAYED_A_SONG = false;
bool BROADCAST = false; //can toggle broadcast (jukebox) mode with # key


long RINGING_TIMER_START;
long RINGING_DURATION = 3500; //rings for 3.5s


long IDLE_TIMER_START;
long IDLE_DURATION = 5000; //this is variable depending on dial
//we use the dial to control the idle duration after use
//these are the min and max values
int IDLE_MIN = 5000;
int IDLE_MAX = 15000;


int TRIGGER_PROXIMITY = 40; //this is variable depending on dial
//we use the dial to control the trigger proximity
//these are the min and max values
int TRIGGER_PROMIXIMITY_MIN = 10;
int TRIGGER_PROMIXIMITY_MAX = 100;
int PROXIMITY_VAL_PREV = 0; //lets do consecutive reads just to make sure its not a glitch


/* i set my mp3 shield to +12db so everything adjusted accordingly */

//for volume, high is low and low is high
//0 is max, 100 is min
//be *very* vareful with the volume over the phone or you can blow that little speaker
float VOL_SPEAKER_MULTIPLIER = 2.0; //1.0 to 5.0 (-= 0.5 each time)
/*
          VOL_R_SPEAKER = int(8*VOL_SPEAKER_MULTIPLIER) + 12; // 52 - 20
          VOL_L_PHONE = VOL_R_SPEAKER + 20; //72 - 40
*/
int VOL_R_SPEAKER = 28; //this is volume when broadcast is true, otherwise it is 100
int VOL_L_PHONE = 48; 











//#############################################################
//#############################################################


//_________________________________________________________
//_________________________________________________________ HANDSET HANGUP SWITCH
//HIGH when in use, LOW when hung up 
//this could be inverted on other phones
int PIN_HANDSET_SWITCH = 21; // make sure this pin supports INPUT_PULLUP. not all Arduino pins do.

//_________________________________________________________
//_________________________________________________________ PROXIMITY SENSOR
int PIN_PROXIMITY_SENSOR = A10;

//_________________________________________________________
//_________________________________________________________ BLINKY LIGHT
int PIN_BLINKY_LIGHT = 50;

//_________________________________________________________
//_________________________________________________________ POTENTIOMETERS FOR TUNING
int PIN_POT_TUNE_DISTANCE = A8; //0-100
int PIN_POT_TUNE_IDLE = A9; 

//_________________________________________________________
//_________________________________________________________ MP3 SHIELD
// include SPI, MP3 and SD libraries
#include <SPI.h>
#include <Adafruit_VS1053.h>
#include <SD.h>
#define SHIELD_RESET  -1      // VS1053 reset pin (unused!)
#define SHIELD_CS     7      // VS1053 chip select pin (output)
#define SHIELD_DCS    6      // VS1053 Data/command select pin (output)
// These are common pins between breakout and shield
#define CARDCS 4     // Card chip select pin
// DREQ should be an Int pin, see http://arduino.cc/en/Reference/attachInterrupt
#define DREQ 3       // VS1053 Data request, ideally an Interrupt pin
Adafruit_VS1053_FilePlayer musicPlayer = Adafruit_VS1053_FilePlayer(SHIELD_RESET, SHIELD_CS, SHIELD_DCS, DREQ, CARDCS);


//_________________________________________________________
//_________________________________________________________ KEYPAD
#include <Keypad.h>
const byte ROWS = 4; // 4 rows
const byte COLS = 4; // 4 columns (may more often be 3)
// Define the Keymap
// for this phone, we had to add another column with */0/#/Z ... not sure why ...
// other phones will likey have 4 rows and 3 columns (7 wires)
//char keys[4][4] = { 
//  {'1','2','3','W'},
//  {'4','5','6','X'},
//  {'7','8','9','Y'},
//  {'*','0','#','Z'}
//};
char keys[4][4] = { //wow something must be messed up with the wiring because i need to make my rows the cols and my cols the rows hmmmm : (
  {'1','4','7','*'},
  {'2','5','8','0'},
  {'3','6','9','#'},
  {'W','X','Y','Z'}
};
//char keys[4][3] = { 
//  {'1','2','3'},
//  {'4','5','6'},
//  {'7','8','9'},
//  {'*','0','#'}
//};
// Connect keypad ROW0, ROW1, ROW2 and ROW3 to these Arduino pins.
byte rowPins[ROWS] = { 28, 26, 24, 22 };
// Connect keypad COL0, COL1 and COL2 to these Arduino pins.
byte colPins[COLS] = { 32, 34, 36, 30 }; 
// Create the Keypad
Keypad kpd = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );





//#############################################################
//#############################################################
void setup() {

  Serial.begin(9600);


  //_________________________________________________________ HANDSET HANGUP SWITCH
  pinMode(PIN_HANDSET_SWITCH, INPUT_PULLUP);
  

  //_________________________________________________________ MP3 SHIELD
  if (! musicPlayer.begin()) { // initialise the music player
     Serial.println(F("Couldn't find MP3 Shield, do you have the right pins defined?"));
     while (1);
  }
  Serial.println(F("MP3 shield found"));
  SD.begin(CARDCS);
  //musicPlayer.setVolume(100,100); //weird, low is loud! left speaker is handset. right speaker is bell. 
  // If DREQ is on an interrupt pin (on uno, #2 or #3) we can do background
  // audio playing
  musicPlayer.useInterrupt(VS1053_FILEPLAYER_PIN_INT);  // DREQ int


  
}







//#############################################################
//#############################################################
void loop() {

  
  TRIGGER_PROXIMITY = map( analogRead(PIN_POT_TUNE_DISTANCE), 0,1024, TRIGGER_PROMIXIMITY_MAX,TRIGGER_PROMIXIMITY_MIN );
  //Serial.print("TRIGGER_PROXIMITY: "); Serial.println(TRIGGER_PROXIMITY);
  IDLE_DURATION = map( analogRead(PIN_POT_TUNE_IDLE), 0,1024, IDLE_MAX,IDLE_MIN );
  //Serial.print("IDLE_DURATION: "); Serial.println(IDLE_DURATION);

  
  switch (MODE) {


    //################################################################################
    case 1: //1 – proximity triggered, ringing
      
      if(DEBUG){ Serial.println("MODE 1"); }

      //bell range is 70-30
      musicPlayer.setVolume( 100, 30 + int(8*VOL_SPEAKER_MULTIPLIER) );  //set volume of bell here. bell.mp3 is VERY loud.

      musicPlayer.startPlayingFile("bell.mp3"); //bell sound
      
      while(musicPlayer.playingMusic){ //stuck in this loop...

        if(DEBUG){ Serial.print("ring..."); }
      
        if(digitalRead(PIN_HANDSET_SWITCH)==LOW){ //phone answered
          musicPlayer.stopPlaying();
          MODE = 2;   
          REPLAY_MODE = true;
        }
        
        if(millis() - RINGING_TIMER_START > RINGING_DURATION){
          musicPlayer.stopPlaying();
          MODE = 0; 
        }

        //we can change ringer volume on the fly
        char key = kpd.getKey();
        if(key=='#'){ 
          VOL_SPEAKER_MULTIPLIER -= 0.5;
          if(VOL_SPEAKER_MULTIPLIER<1.0){ VOL_SPEAKER_MULTIPLIER=5.0; }
          musicPlayer.setVolume( 100, 40 + int(8*VOL_SPEAKER_MULTIPLIER) );  //set volume of bell here. bell.mp3 is VERY loud.
          VOL_R_SPEAKER = int(8*VOL_SPEAKER_MULTIPLIER) + 12; // 52 - 20
          VOL_L_PHONE = VOL_R_SPEAKER + 20; //72 - 40
        }
  
        delay(50);

      }
      
      break;


    //################################################################################
    case 2: //2 – in use

      if(DEBUG){ Serial.println("MODE 2"); }

      if(BROADCAST){
        musicPlayer.setVolume( VOL_L_PHONE, VOL_R_SPEAKER ); 
      }else{
        musicPlayer.setVolume( VOL_L_PHONE, 100 ); //mute speaker
      }

      if(REPLAY_MODE){ //we just keep replaying hello message until digit is clicked
        
        if(DEBUG){ Serial.println("Play hello..."); }
        musicPlayer.stopPlaying();
        musicPlayer.startPlayingFile("hello.mp3"); //play hello
        
      }

      //read keypad
      keypad_to_song();

      if(digitalRead(PIN_HANDSET_SWITCH)==HIGH){ //hung up
        
        if(DEBUG){ Serial.println("hung up"); }
        musicPlayer.stopPlaying();
        MODE = 3;
        IDLE_TIMER_START = millis();
        
      }

      //when music or message is playing we are stuck in this loop :U
      while (musicPlayer.playingMusic){

        if(digitalRead(PIN_HANDSET_SWITCH)==HIGH){  //hung up
          if(DEBUG){ Serial.println("hung up"); }
          musicPlayer.stopPlaying();
          MODE = 3;
          IDLE_TIMER_START = millis();
          PLAYED_A_SONG = false;
        }

        //read keypad
        keypad_to_song();
        
      }

      if(PLAYED_A_SONG){ //we are here because a song has finished playing. why don't we randomly play another?
        if(DEBUG){ Serial.println("Song Finished... Randomly playing another..."); }
        int randIdx = int(random(0,9));
        String songnum = String(randIdx);
        String song = "song"+songnum+".mp3";
        //song1.mp3 string length is 9
        char filename[10]; //learned the hard way about null termination. fuk you C! 
        song.toCharArray(filename, 10);
        musicPlayer.startPlayingFile(filename); 
      }
        
      break;


    //################################################################################
    case 3: //3 – hangup, idle for XXXXms

      BROADCAST = false;
      
      PLAYED_A_SONG = false;
      
      if(DEBUG){ Serial.println("MODE 3"); }

      //idle timer (to prevent it from ringing right away)
      if(millis() - IDLE_TIMER_START > IDLE_DURATION){
        MODE = 0;
      }

      if(digitalRead(PIN_HANDSET_SWITCH)==LOW){ //pick up
        musicPlayer.stopPlaying();
        MODE = 2;   
        REPLAY_MODE = true;
      }
      
      break;


    //################################################################################  
    default: //0 – waiting

      if(DEBUG){Serial.println("MODE 0");}
      
      if(DEBUG){ 
        Serial.print("Distance sensor: ");
        Serial.println( analogRead(PIN_PROXIMITY_SENSOR) );
        }

      //got two readings in a row below sensor threshold
      if(analogRead(PIN_PROXIMITY_SENSOR) < TRIGGER_PROXIMITY){
        if(PROXIMITY_VAL_PREV < TRIGGER_PROXIMITY){
          MODE = 1;
          RINGING_TIMER_START = millis();
        }
      }
      PROXIMITY_VAL_PREV = analogRead(PIN_PROXIMITY_SENSOR);
      
      delay(100);
    
    break;


    
  }


  


}







void keypad_to_song(){
  

  char key = kpd.getKey();
  if(key){
    if(DEBUG){ Serial.println(key); }
    REPLAY_MODE = false;
  }else{
    return;
  }
  

  // key: # ---------------------------------------------------------------------
  if(key=='#'){ //volume

//    if(DEBUG){ Serial.println("#"); }
//    musicPlayer.stopPlaying();
//    musicPlayer.playFullFile("dpound.mp3");
    
    VOL_SPEAKER_MULTIPLIER -= 0.5;
    
    if(VOL_SPEAKER_MULTIPLIER<1.0){ VOL_SPEAKER_MULTIPLIER=5.0; }
    
    VOL_R_SPEAKER = int(8*VOL_SPEAKER_MULTIPLIER) + 12; // 52 - 20
    VOL_L_PHONE = VOL_R_SPEAKER + 20; //72 - 40

    if(DEBUG){
      Serial.print("Volume phone :");
      Serial.println(VOL_L_PHONE);
      Serial.print("Volume speaker :");
      Serial.println(VOL_R_SPEAKER);
    }

    if(BROADCAST){
      musicPlayer.setVolume(  VOL_L_PHONE, VOL_R_SPEAKER );  
    }else{
      musicPlayer.setVolume(  VOL_L_PHONE, 100 ); //speaker is mute
    }
    
  }


  // key: * ---------------------------------------------------------------------
  if(key=='*'){ //toggle broadcast

//    if(DEBUG){ Serial.println("*"); }
//    musicPlayer.stopPlaying();
//    musicPlayer.playFullFile("dstar.mp3");
    
    BROADCAST = !BROADCAST;
    
    if(BROADCAST){
      musicPlayer.setVolume(  VOL_L_PHONE, VOL_R_SPEAKER );  
    }else{
      musicPlayer.setVolume(  VOL_L_PHONE, 100 ); //speaker is mute
    }
    
  }


  // key: 0-9 ---------------------------------------------------------------------
  
  if(key=='1'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d1.mp3");
    musicPlayer.startPlayingFile("song1.mp3"); 
  }
  
  if(key=='2'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d2.mp3");
    musicPlayer.startPlayingFile("song2.mp3"); 
  }
  
  if(key=='3'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d3.mp3");
    musicPlayer.startPlayingFile("song3.mp3"); 
  }
  
  if(key=='4'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d4.mp3");
    musicPlayer.startPlayingFile("song4.mp3"); 
  }
  
  if(key=='5'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d5.mp3");
    musicPlayer.startPlayingFile("song5.mp3"); 
  }
  
  if(key=='6'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d6.mp3");
    musicPlayer.startPlayingFile("song6.mp3"); 
  }
  
  if(key=='7'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d7.mp3");
    musicPlayer.startPlayingFile("song7.mp3"); 
  }
  
  if(key=='8'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d8.mp3");
    musicPlayer.startPlayingFile("song8.mp3"); 
  }
  
  if(key=='9'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d9.mp3");
    musicPlayer.startPlayingFile("song9.mp3"); 
  }
  
  if(key=='0'){
    musicPlayer.stopPlaying();
    musicPlayer.playFullFile("d0.mp3");
    musicPlayer.startPlayingFile("song0.mp3"); 
  }

}































/*
  we are not using this 
  but if you want to have codes (multi number codes) play songs
  this code will be useful
  for example, 
  punching in 3950 could play a specific song, 
  and the phone could store MILLIONS of songs


void code_entered(){

  TIMEOUT_DIGIT = false;

  String code_4 = String(CODE_ENTERED[0]) + String(CODE_ENTERED[1]) + String(CODE_ENTERED[2]) + String(CODE_ENTERED[3]);

  bool song_was_found = false;
  for(int i=0;i<NUM_SONGS;i++){
    if(code_4 == SONGS[i]){
      
      song_was_found = true;

      CODE_COUNTER = 0;
      TIMEOUT_DIGIT = false;
      
      if(DEBUG==true){Serial.println("Song Found...");Serial.println(SONGS[i]+".mp3");}
      
      String s = SONGS[i]+".mp3";
      char filename[9]; //learned the hard way about null termination. fuk you C! 
      s.toCharArray(filename, 9);
      musicPlayer.startPlayingFile(filename); 
      
      PLAYED_A_SONG = true;
      
    }
  }

  if(song_was_found == false){
    CODE_COUNTER = 0;
    TIMEOUT_DIGIT = false;
    musicPlayer.startPlayingFile("sorry2.mp3");  
  }
  
}


void play_song(String song){

      CODE_COUNTER = 0;
      TIMEOUT_DIGIT = false;
      
      String s = song+".mp3";

      if(DEBUG){ Serial.println(song+".mp3"); }
      
      char filename[9]; //learned the hard way about null termination. fuk you C! 
      
      s.toCharArray(filename, 9);

      musicPlayer.startPlayingFile(filename); 
      
}

*/
